/* ACRGfB^ */
#include "guisys.h"
#include "chooser.h"

/* R|[lg */
FileChooser chooser;
Window      edit_window;
Menu        file_menu;
Menu        open_menu;
Menu        save_menu;
Menu        exit_menu;

Button      inc_icon_no;
Button      dec_icon_no;
Label       icon_no_disp;
Button      recall_icon;
Button      regist_icon;

Button      icon_display;
Label       color_indicater;
Button      color_button[ 16 ];

/* ϐ */
BYTE        work[ 256 ];
char        numbuf[ 8 ];
int         icon_no;
int         current_color;

/* ֐̃vg^Cv錾 */
void edit_exit_action( Component* );
void edit_open_action( Component* );
void edit_save_action( Component* );
void edit_resize_action(Component* );
void edit_dec_icon_no_action( Component* );
void edit_inc_icon_no_action( Component* );
void edit_recall_icon_action( Component* );
void edit_regist_icon_action( Component* );
void edit_pset_action( Component* );
void edit_change_color_action( Component* );
void edit_display_icon( Component* );
int read_icon( char* path );
int write_icon( char* path );

/* AvP[VN */
void WinMain( int argc, char** argv ){
  int i;

  createFileChooser( &chooser );
  createWindow( &edit_window, NULL, " ި", NULL );
  edit_window.close_action  = edit_exit_action;
  edit_window.resize_action = edit_resize_action;
  setBounds( &edit_window.component, 10, 10, 320, 370 );

  createMenu( &file_menu, NULL, &edit_window.component, "̧" );
  setBounds( &file_menu.item.component, 18, 26, 40, 18 );
  createSubMenu( &open_menu, NULL, &file_menu, " J" );
  open_menu.select_action   = edit_open_action;
  createSubMenu( &save_menu, NULL, &file_menu, " ۑ" );
  save_menu.select_action   = edit_save_action;
  createSubMenu( &exit_menu, NULL, &file_menu, " I" );
  exit_menu.select_action   = edit_exit_action;

  createLabel( &color_indicater, NULL, &edit_window.component, "" );
  setBounds( &color_indicater.component, 64, 26, 42, 18 );
  color_indicater.component.is_visible = TRUE;
  color_indicater.component.border = RAISED_BORDER;
  createButton( &dec_icon_no, NULL, &edit_window.component, "-" );
  dec_icon_no.click_action = edit_dec_icon_no_action;
  setBounds( &dec_icon_no.component, 118, 26, 9, 18 );
  dec_icon_no.component.is_visible = TRUE;
  createLabel( &icon_no_disp, NULL, &edit_window.component, "0" );
  setBounds( &icon_no_disp.component, 129, 26, 18, 18 );
  icon_no_disp.component.is_visible = TRUE;
  icon_no_disp.component.border = LOWERD_BORDER;
  icon_no_disp.component.background = COLOR_WHITE;
  createButton( &inc_icon_no, NULL, &edit_window.component, "+" );
  inc_icon_no.click_action = edit_inc_icon_no_action;
  setBounds( &inc_icon_no.component, 150, 26, 9, 18 );
  inc_icon_no.component.is_visible = TRUE;
  createButton( &recall_icon, NULL, &edit_window.component, "ďo" );
  recall_icon.click_action = edit_recall_icon_action;
  setBounds( &recall_icon.component, 174, 26, 36, 18 );
  recall_icon.component.is_visible = TRUE;
  createButton( &regist_icon, NULL, &edit_window.component, "o^" );
  regist_icon.click_action = edit_regist_icon_action;
  setBounds( &regist_icon.component, 226, 26, 36, 18 );
  regist_icon.component.is_visible = TRUE;
  createButton( &icon_display, NULL, &edit_window.component, "" );
  icon_display.click_action = edit_pset_action;
  icon_display.paint = edit_display_icon;
  setBounds( &icon_display.component, 15, 72, 288, 288 );
  icon_display.component.is_visible = TRUE;
  for( i = 0; i < 16; i++ ){
    createButton( &color_button[ i ], NULL, &edit_window.component, "" );
    color_button[ i ].component.background = i;
    color_button[ i ].click_action =  edit_change_color_action;
    if( i == COLOR_CLEAR ) setTextButton( &color_button[ i ], "w" );
    setBounds( &color_button[ i ].component, 15 + i * 18, 48, 18, 18 );
    color_button[ i ].component.is_visible = TRUE;
  }
  memcpy( work, getIconAddress( icon_no = 0 ), 256 );
  if( argc > 1 && read_icon( argv[1] ) ) showOKDialog( "ǂݏoG[" );
  current_color = color_indicater.component.background = COLOR_BLACK;
  showWindow( &edit_window );
}

/* I */
void edit_exit_action( Component* com ){
  quitGUI();
}

/* J */
void edit_open_action( Component* com ){
  char  path[128];
  if( showOpenDialog( &chooser, path )) return;
  if( read_icon( path ) ){
    showOKDialog( "ǂݏoG[" );
    return;
  }
  paintComponent( &desktop.component );
}

/* ۑ */
void edit_save_action( Component* com ){
  char  path[128];
  if( showSaveDialog( &chooser, path ) ) return;
  if( write_icon( path ) ){
    showOKDialog( "݃G[" );
    return;
  }
  paintComponent( &desktop.component );
}

/* EBhETCYύXꂽ */
void edit_resize_action( Component* com ){
  setBounds( com, com->x0, com->y0, 320, 370 );
  paintComponent( &desktop.component );
}

/* ACRԍ -1  */
void edit_dec_icon_no_action( Component* com ){
  if( --icon_no < 0 ) icon_no = 0;
  setTextLabel( &icon_no_disp, itoa( icon_no, numbuf, 10 ) );
}

/* ACRԍ +1  */
void edit_inc_icon_no_action( Component* com ){
  if( ++icon_no > 31 ) icon_no = 31;
  setTextLabel( &icon_no_disp, itoa( icon_no, numbuf, 10 ) );
}

/* \Ăԍ̃ACRVXeĂяo */
void edit_recall_icon_action( Component* com ){
  memcpy( work, getIconAddress( icon_no ), 256 );
  paintComponent( &desktop.component );
}

/* \Ăԍ̃ACRVXeɓo^ */
void edit_regist_icon_action( Component* com ){
  char msg[64];

  strcpy( msg, "(" );
  strcat( msg, icon_no_disp.text );
  strcat( msg, ") o^܂H" );
  if( showYesNoDialog( msg ) == 1 ) memcpy( getIconAddress( icon_no ), work, 256 );
  paintComponent( &desktop.component );
}

/* _ł */
void edit_pset_action( Component* com ){
  work[ ( MouseCursorX - com->x0_abs ) / 18 + ( MouseCursorY - com->y0_abs ) / 18 * 16 ] = current_color;
  paintComponent( com );
}

/* _łƂ̐Fς */
void edit_change_color_action( Component* com ){
  current_color = color_indicater.component.background = com->background;
  paintComponent( &color_indicater.component );
}

/* ACR\ */
void edit_display_icon( Component* com ){
  int x, y, c;
  for( y = 0; y < 16; y++ ){
    for( x = 0; x < 16; x++ ){
      setColor( c = work[ x + 16 * y ], FALSE );
      drawFillRect( com->x0_abs + 18 * x, com->y0_abs + 18 * y, 18, 18 );
      if( c == COLOR_CLEAR ){
        setColor( COLOR_BLACK, FALSE );
        drawString( com->x0_abs + 18 * x, com->y0_abs + 18 * y, 18, "w" );
      }
    }
  }
}

/* t@CACRobt@ɓǂݍ */
int read_icon( char* path ){
  int  fd;

  if( ( fd = open( path, O_RDONLY ) ) < 0 ) return TRUE;
  read( fd, work, 256 );
  close( fd );
  icon_no = work[0];
  work[0] = COLOR_CLEAR;
  icon_no_disp.text = itoa( icon_no, numbuf, 10 );
  return FALSE;
}

/* ACRobt@t@C֏ */
int write_icon( char* path ){
  int  fd;

  if( ( fd = open( path, O_WRONLY | O_CREAT, S_IREAD | S_IWRITE ) ) < 0 ) return TRUE;
  work[0] = icon_no;
  write( fd, work, 256 );
  close( fd );
  return FALSE;
}
